<?php

/*
  
  File: menu.php3
  $Author: rich $
  $Revision: 2.9.2.18 $
  $Date: 2000/09/13 17:07:22 $
  
  IMP: Copyright 1998, 1999, 2000 Charles J. Hagenbuch <chuck@horde.org>
  
  You should have received a copy of the GNU Public
  License along with this package; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
  
*/

function set_menu ($text) {
	global $default;
  
	/* skip any comment lines */
	if (preg_match("|([^#]*)#.*|", $text, $regs)) {
		$text = $regs[1];
    
		/* If there was something before the comment, make it a complete line */
		if (strlen($text) > 0) {
			$text = $text . "\n";
		}
	}
	if (strstr($text, '<SEPERATOR>')) {
		$text = '<tr><td colspan="2">&nbsp;</td></tr>' . "\n";
	} elseif (preg_match("|(.*)<(.*)>(.*)\n|", $text, $regs)) {
		$text = '<tr bgcolor="' . $default->dark_bg. '"><td valign="top"><a class="menuitem" href="' . $regs[1]. '" target="_blank"><img border="0" align="top" src="' . $default->graphics_url . '/' . $regs[3] . '" width="18" height="18" alt="' . $regs[2] . '"></a></td><td><a class="menuitem" href="' . $regs[1]. '" target="_blank"><font size="' . $default->font->size . '" face="' . $default->font->face. '">' . $regs[2] . '</font></a></td></tr>' . "\n";
	}
	return $text;
}


require '../lib/horde.lib';
require './lib/imp.lib';           /* IMPlib is the IMP function library  */
require '../config/horde.php3';
require './config/defaults.php3';  /* Defaults configuration file */
require './config/html.php3';
require './config/lang.php3';

$language = select_lang();
require './lib/postconf.php3';
require "./locale/$language/menu.lang";
require './locale/local/menu.lang';
require './config/lang.php3';

$this_client = new WebClient;

error_reporting($default->error_level);  /* set error level from imp.lib   */

/* if there is an existing session, display the full menu */
page_open(array('sess' => 'HordeSession'));
page_close();
if (isset($imp)) {
    $menu = IMPMENU_MAIN;
    $imp->unpickle();
}

$extra_menus = '';
$menu_array = @file('./config/menu.txt');
if (@count($menu_array) > 0) {
	$extra_menus .= "<tr><td>&nbsp;</td></tr>\n";
}
for ($j = 0; $j < count($menu_array); $j++) {
	$extra_menus .= set_menu($menu_array[$j]);
}

if (!isset($menu)) $menu = IMPMENU_DORMANT;
if ($menu == IMPMENU_DORMANT) $title = $lang->login_again;

$sidebar = true;
require "$default->include_dir/doctype.inc";
require "$default->include_dir/generic-header.inc";
if (!$default->minimum_popups && !$this_client->rather_not_popup) {
	include './lib/js/open_compose_win.js';
}
require './lib/js/open_contacts.js';
if ($menu != IMPMENU_BLANK) {
	include "$default->include_dir/menu/main.inc";
}
require "$default->include_dir/generic-footer.inc";

?>
